/*
 * NRF_EIGEN.c
 *
 * Created: 23.06.2016 17:19:57
 *  Author: Florian
 */ 

#define F_CPU 8000000
#include <avr/io.h>
#include <avr/delay.h>
#include "nRF24L01.h"
#include "../../../Alte Projekte/MeineHeader/lcd-funktionen_an_PORTC.h"
#include "../../../Alte Projekte/MeineHeader/Eigener_USART.h"


volatile uint8_t debugflags;
#define data_sent ((1<<0))
#define data_ready ((1<<1))

void check_debugflags(void)
{
	lcd_home();
	if (debugflags)
	{
		
		if (debugflags&(1<<data_sent))
		{
			debugflags &= ~(1<<data_sent);
			lcd_string("data send");
			
		}
		if (debugflags&(1<<data_ready))
		{
			debugflags &= ~(1<<data_ready);
			lcd_string("data ready");
		}		
	}
	else
	{
		lcd_home();
		lcd_string("keine flags");
	}
	_delay_ms(1000);

}

void nrf24_init(uint8_t bool_rx)
{
	spi_init();
	nrf_port|= (1<<CSN_pin);
	nrf_ddr |= (1<<CE_pin)|(1<<CSN_pin);
	_delay_us(20);
	
	if (bool_rx ==1)
	{
		//PRX:
		
// 		 Power up the PRX device and set PRIM_RX bit to 1:
// 		Write 0x0b to the CONFIG register.
		nrf_port &= ~(1<<CSN_pin);
		spi_fast_shift(W_REGISTER|NRF_CONFIG);
		spi_fast_shift(0x0B);
		nrf_port |= (1<<CSN_pin);
		_delay_us(20);
		
// 		 Set Payload Width, (e.g. 8 bytes for data pipe 0):
// 		Write 8 to RX_PW_P0
		nrf_port &= ~(1<<CSN_pin);
		spi_fast_shift(W_REGISTER|RX_PW_P0);
		spi_fast_shift(8);
		nrf_port |= (1<<CSN_pin);
		_delay_us(20);

// 		 Set CE = 1, and the PRX will be ready to receive 8 byte packets at the default
// 		address and frequency.
		nrf_port |= (1<<CE_pin);
	}
	else
	{
		nrf_port &= ~(1<<CSN_pin); 
		spi_fast_shift(W_REGISTER|NRF_CONFIG);
		spi_fast_shift(0x0A);
		nrf_port |= (1<<CSN_pin); 
	}
		
}

void nrf24_communicate(uint8_t bool_rx, uint8_t* payload)
{
	if (bool_rx == 1)
	{
// 		PRX:
// 		 Set CE high.
		nrf_port |= (1<<CE_pin);
		
// 		 Wait for interrupt (IRQ pin low).
		lcd_home();
		lcd_string("Wait IRQ");
		while(PIND & (1<<IRQ_pin)){};
		lcd_home();
		lcd_string("IRQ occured");

// 		 Check status register for RX_DR interrupt (data ready)
		nrf_port &= ~(1<<CSN_pin);
		uint8_t nrf_status = spi_fast_shift(NOP);
		nrf_port |= (1<<CSN_pin);
		
		if (nrf_status & RX_DR)
		{
			//data ready (to be read)
			lcd_home();
			lcd_clear();
			lcd_string("data ready");
		}
		
// 		 Read RX Payload:
// 		Execute SPI instruction: R_RX_PAYLOAD
		nrf_port &= ~(1<<CSN_pin);
		spi_fast_shift(R_RX_PAYLOAD);
		
		for (uint8_t i = 0; i< 5;i++)
		{
			payload[i] = spi_fast_shift(NOP); // NOP oder anderen befehl whrend des Lesens? 
		}		
		nrf_port |= (1<<CSN_pin);
		_delay_ms(20);
// 		 Optional: Standby-I mode can be entered after packet receive by setting CE
// 		low.
// 		Note: The PRX will send an acknowledgement packet to the PTX after
// 		successful receive. This will be done even if the CE pin is set low immediately
// 		after RX_DR interrupt. Though it is recommended to keep CE high long
// 		enough to capture potential retransmits from PTX in case of lost
// 		acknowledges. (PRX also acknowledges retransmitted packets.) If PRX is
// 		turned off immediately and the (in this case only) acknowledgement packet is
// 		lost, the PTX will retransmit the packet repeatedly until Auto Retransmit
// 		Count (ARD) is reached, thus dissipating unnecessary power.
		nrf_port &= ~(1<<CE_pin);

// 		 Optional: Power Down mode can be entered from Standby-I mode:
// 		Write 0x09 to the CONFIG register.
// 		nrf_port &= ~(1<<CSN_pin);
// 		spi_fast_shift(W_REGISTER| 0x09);
// 		nrf_port |= (1<<CSN_pin);
		
	}
	else
	{
		
// 		PTX:

// 		 Upload 8 byte payload to TX FIFO of PTX.
// 		Execute SPI instruction: W_TX_PAYLOAD <payload>
		nrf_port &= ~(1<<CSN_pin);
		spi_fast_shift(W_TX_PAYLOAD);
		spi_fast_shift(0x00);
		spi_fast_shift(0x01);
		spi_fast_shift(0x02);
		spi_fast_shift(0x03);
		spi_fast_shift(0x04);
		nrf_port |= (1<<CSN_pin);
		_delay_us(20);

// 		 Pulse CE high.
		nrf_port |= (1<<CE_pin);

// 		 Wait for interrupt (IRQ pin low).
		lcd_home();
		lcd_string("Wait IRQ");
		while(PIND & (1<<2)){};
		lcd_home();
		lcd_string("IRQ occured");
		_delay_ms(1000);
		
// 		 Check status register for TX_DS interrupt (data sent)
		nrf_port &= ~(1<<CSN_pin);
		uint8_t nrf_status = spi_fast_shift(NOP);
		nrf_port |= (1<<CSN_pin);
		
		if (nrf_status & (1<<TX_DS))
		{
			lcd_home();
			lcd_string("data sent!");// Daten wurden gesendet
		}
		
// 		 Optional: Power Down mode can be entered after packet transmit:
// 		Write 0x08 to the CONFIG register.
// 		nrf_port &= ~(1<<CSN_pin);
// 		spi_fast_shift(W_REGISTER|NRF_CONFIG);
// 		spi_fast_shift(0x08);
// 		nrf_port |= (1<<CSN_pin);
		
	}
}

int main(void)
{
	lcd_init();
	lcd_home();
	lcd_string("Status 0");
	//receiver!!
	nrf24_init(1);
	uint8_t payload[8]={0,0,0,0,0,0,0,0};
	char asciiBuffer[9];
	_delay_ms(1000);
		
	//status_check
	nrf_port &= ~(1<<CSN_pin);
	uint8_t nrf_status = spi_fast_shift(NOP);
	nrf_port |= (1<<CSN_pin);
	utoa(nrf_status,asciiBuffer,2);
	lcd_clear();
	lcd_home();
	lcd_string(asciiBuffer);
	
	_delay_ms(2000);
	
	
	
    while(1)
    {
		_delay_ms(2000);
		nrf24_communicate(1,payload);
		lcd_clear();
		lcd_home();
		lcd_string("com done");
		
        //TODO:: Please write your application code 
    }
}