/*
 * NRF_EIGEN.c
 *
 * Created: 23.06.2016 17:19:57
 *  Author: Florian
 */ 

#define F_CPU 16000000
#include <avr/io.h>
#include <avr/delay.h>
#include "nRF24L01.h"
//#include "../../../Alte Projekte/MeineHeader/lcd-funktionen_an_PORTC.h"
#include "../../../Alte Projekte/MeineHeader/Eigener_USART.h"


volatile uint8_t debugflags;
#define data_sent ((1<<0))
#define data_ready ((1<<1))

void check_debugflags(void)
{
	char buffer[20];
	if (debugflags)
	{
		
		if (debugflags&(1<<data_sent))
		{
			debugflags &= ~(1<<data_sent);
			USART_PC_message("\ndata sent\n",buffer);
			
		}
		if (debugflags&(1<<data_ready))
		{
			debugflags &= ~(1<<data_ready);
			USART_PC_message("\ndata ready\n",buffer);
		}		
	}
	else
	{
		USART_PC_message("\nkeine flags\n",buffer);
	}
	_delay_ms(1000);

}

void nrf24_init(uint8_t bool_rx)
{
	spi_init();
	nrf_port|= (1<<CSN_pin);
	nrf_ddr |= (1<<CE_pin)|(1<<CSN_pin);
	_delay_us(20);
	
	if (bool_rx ==1)
	{
		//PRX:
		
// 		 Power up the PRX device and set PRIM_RX bit to 1:
// 		Write 0x0b to the CONFIG register.
		nrf_port &= ~(1<<CSN_pin);
		spi_fast_shift(W_REGISTER|NRF_CONFIG);
		spi_fast_shift(0x0B);
		nrf_port |= (1<<CSN_pin);
		_delay_us(20);
		
// 		 Set Payload Width, (e.g. 8 bytes for data pipe 0):
// 		Write 8 to RX_PW_P0
		nrf_port &= ~(1<<CSN_pin);
		spi_fast_shift(W_REGISTER|RX_PW_P0);
		spi_fast_shift(8);
		nrf_port |= (1<<CSN_pin);
		_delay_us(20);

// 		 Set CE = 1, and the PRX will be ready to receive 8 byte packets at the default
// 		address and frequency.
		nrf_port |= (1<<CE_pin);
	}
	else
	{
		nrf_port &= ~(1<<CSN_pin); 
		spi_fast_shift(W_REGISTER|NRF_CONFIG);
		spi_fast_shift(0x0A);
		nrf_port |= (1<<CSN_pin); 
	}
		
}

void nrf24_communicate(uint8_t bool_rx, uint8_t* payload)
{
	char buffer[20];
	if (bool_rx == 1)
	{
// 		PRX:
// 		 Set CE high.
		nrf_port |= (1<<CE_pin);
		
// 		 Wait for interrupt (IRQ pin low).
		USART_PC_message("\nWait IRQ\n",buffer);
		while(PIND & (1<<IRQ_pin)){};
		USART_PC_message("\nIRQ occured\n",buffer);

// 		 Check status register for RX_DR interrupt (data ready)
		nrf_port &= ~(1<<CSN_pin);
		uint8_t nrf_status = spi_fast_shift(NOP);
		nrf_port |= (1<<CSN_pin);
		
		if (nrf_status & RX_DR)
		{
			//data ready (to be read)
			USART_PC_message("\ndata ready\n",buffer);
		}
		
// 		 Read RX Payload:
// 		Execute SPI instruction: R_RX_PAYLOAD
		nrf_port &= ~(1<<CSN_pin);
		spi_fast_shift(R_RX_PAYLOAD);
		
		for (uint8_t i = 0; i< 5;i++)
		{
			payload[i] = spi_fast_shift(NOP); // NOP oder anderen befehl whrend des Lesens? 
		}		
		nrf_port |= (1<<CSN_pin);
		_delay_ms(20);
// 		 Optional: Standby-I mode can be entered after packet receive by setting CE
// 		low.
// 		Note: The PRX will send an acknowledgement packet to the PTX after
// 		successful receive. This will be done even if the CE pin is set low immediately
// 		after RX_DR interrupt. Though it is recommended to keep CE high long
// 		enough to capture potential retransmits from PTX in case of lost
// 		acknowledges. (PRX also acknowledges retransmitted packets.) If PRX is
// 		turned off immediately and the (in this case only) acknowledgement packet is
// 		lost, the PTX will retransmit the packet repeatedly until Auto Retransmit
// 		Count (ARD) is reached, thus dissipating unnecessary power.
		nrf_port &= ~(1<<CE_pin);

// 		 Optional: Power Down mode can be entered from Standby-I mode:
// 		Write 0x09 to the CONFIG register.
// 		nrf_port &= ~(1<<CSN_pin);
// 		spi_fast_shift(W_REGISTER| 0x09);
// 		nrf_port |= (1<<CSN_pin);
		
	}
	else
	{
		
// 		PTX:

//---??? zuerst noch fifo tx lschen?
		nrf_port &= ~(1<<CSN_pin);
		spi_fast_shift(FLUSH_TX);
		nrf_port |= (1<<CSN_pin);
		_delay_us(20);

// 		 Upload 8 byte payload to TX FIFO of PTX.
// 		Execute SPI instruction: W_TX_PAYLOAD <payload>
		nrf_port &= ~(1<<CSN_pin);
		spi_fast_shift(W_TX_PAYLOAD);
		for (uint8_t i=1;i<8;i++)
		{
			spi_fast_shift(0b01010101);
		}
// 		spi_fast_shift(0x00);
// 		spi_fast_shift(0x01);
// 		spi_fast_shift(0x02);
// 		spi_fast_shift(0x03);
// 		spi_fast_shift(0x04);
// 		spi_fast_shift(0x05);
// 		spi_fast_shift(0x06);
// 		spi_fast_shift(0x07);
 		nrf_port |= (1<<CSN_pin);
		_delay_us(20);

// 		 Pulse CE high.
		nrf_port |= (1<<CE_pin);
		// ???zu pulse ce high:
		_delay_us(20);
		//nrf_port &= ~(1<<CE_pin);

// 		 Wait for interrupt (IRQ pin low).
		USART_PC_message("\nWait IRQ\n",buffer);
		while(PIND & (1<<2)){};
		USART_PC_message("\nIRQ occured\n",buffer);
		_delay_ms(1000);
		

		
// 		 Check status register for TX_DS interrupt (data sent)
		nrf_port &= ~(1<<CSN_pin);
		uint8_t nrf_status = spi_fast_shift(NOP);
		nrf_port |= (1<<CSN_pin);
		
		if (nrf_status & (1<<TX_DS))
		{
			USART_PC_message("\ndata sent\n",buffer);	// Daten wurden gesendet
		}
		
// 		 Optional: Power Down mode can be entered after packet transmit:
// 		Write 0x08 to the CONFIG register.
// 		nrf_port &= ~(1<<CSN_pin);
// 		spi_fast_shift(W_REGISTER|NRF_CONFIG);
// 		spi_fast_shift(0x08);
// 		nrf_port |= (1<<CSN_pin);
		
	}
}

uint8_t nrf24_getSTATUS(void)
{
	nrf_port &= ~(1<<CSN_pin);
	uint8_t nrf_status = spi_fast_shift(NOP);
	nrf_port |= (1<<CSN_pin);
	return nrf_status;
}

void nrf24_clearALL_IRQ(void)
{
	nrf_port &= ~(1<<CSN_pin);
	uint8_t nrf_status = spi_fast_shift(NOP);
	nrf_port |= (1<<CSN_pin);
	
	nrf_status = nrf_status & ((1<<RX_DR) | (1<<TX_DS) | (1<<MASK_MAX_RT));
	
	nrf_port &= ~(1<<CSN_pin);
	spi_fast_shift(W_REGISTER|NRF_STATUS);
	spi_fast_shift(nrf_status);
	nrf_port |= (1<<CSN_pin);
	_delay_us(20);	
}





int main(void)
{
	char asciiBuffer[25];
	USART_INIT_PC_HTerm();
	for (uint8_t i=0;i<10;i++)
	{
		_delay_ms(1000);
		USART_PC_message("\n",asciiBuffer);
	}
	//receiver!!
	nrf24_init(0);
	uint8_t payload[8]={0,0,0,0,0,0,0,0};
	
	_delay_ms(1000);
		
	//status_check
	uint8_t nrf_status = nrf24_getSTATUS();
	utoa(nrf_status,asciiBuffer,2);
	USART_PC_message_with_uint_8("",asciiBuffer,nrf_status,2);
	
	_delay_ms(2000);
	
	
	
    while(1)
    {
		_delay_ms(2000);
		nrf24_communicate(0,payload);
		USART_PC_message("\ncom done\n",asciiBuffer);
		
		_delay_ms(2000);
		
		//status_check
		uint8_t nrf_status = nrf24_getSTATUS();
		utoa(nrf_status,asciiBuffer,2);
		USART_PC_message_with_uint_8("",asciiBuffer,nrf_status,2);
		
		_delay_ms(2000);
		
		nrf24_clearALL_IRQ();
		
		//status_check
		nrf_status = nrf24_getSTATUS();
		utoa(nrf_status,asciiBuffer,2);
		USART_PC_message_with_uint_8("\ncleared IRQ:\n",asciiBuffer,nrf_status,2);
		
		_delay_ms(2000);

        //TODO:: Please write your application code 
    }
}